
Figure - Bug #118047
Bug # 117821 (CLOSED): 【VC1】【内部】【0094】【台架】【EE环境】【副屏】系统无响应自动重启

IOVDEV-28927 【自动化测试】【稳定性测试】【VC1】【副屏】com.android.music ANR
2023-05-18 16:38 - CDTS-TEST 周婷

Status: CLOSED Start date: 2023-05-18

Priority: Normal Due date:

Assignee: CDTS-TEST 周婷 % Done: 0%

Category: AUDIO-FW Estimated time: 0.00 hour

Target version:

Need_Info: -- Found Version: 01.00.0095

Resolution: DUPLICATE Degrated: --

Severity: Major Verified Version:

Reproducibility: Occasionally Fixed Version:

Test Type: Free Test Root cause: 和117821问题一致

Description

测试手顺：

副屏执行monkey稳定性测试

预期结果：

无黑卡死等严重问题发生，无Crash、ANR、Tombstone内存泄露等

实际结果：

com.android.music ANR

副屏版本： 

01.00.0095.c103

History

#1 - 2023-05-18 16:39 - CDTS-TEST 周婷

全量日志联系王成或者周婷

#2 - 2023-05-18 17:57 - CD FW 曹覃刚

- Category changed from CD-FW to 依赖客户及其供应商解决

- Status changed from New to NEED_INFO

- Assignee changed from CD FW 曹覃刚 to CDTS-TEST 周婷

Hi 周婷

与 #118045 一致 (客户jira票中此问题上传的日志与 #118045 相同)

客户上传的日志是实时日志，不是历史日志

请帮忙确认日志是否抓取正确以及上传正确

#3 - 2023-05-26 11:30 - CDTS_TEST 王成
#4 - 2023-05-26 11:30 - CDTS_TEST 王成

- Status changed from NEED_INFO to ASSIGNED

- Assignee changed from CDTS-TEST 周婷 to CD FW 曹覃刚

附件为客户提供的新日志

#5 - 2023-05-26 13:59 - CD FW 曹覃刚

- Category changed from 依赖客户及其供应商解决 to AUDIO-FW

- Assignee changed from CD FW 曹覃刚 to Multimedia组-RD3_TSCD 梁卿山

■ 我的分析

anr_2023-05-24-06-10-59-049

com.android.music ANR

下列3个线程相互持有对方等待的资源, 形成死锁，堆栈信息是在处理Audio的焦点

---------------------------

"Thread-12" prio=5 tid=98 Blocked  | group="main" sCount=1 ucsCount=0 flags=1 obj=0x13f45c10 self=0xb400007540147ef0  | sysTid=1809 nice=0 cgrp=default

sched=0/0 handle=0x72e0596cb0  | state=S schedstat=( 330830792 368615844 2058 ) utm=20 stm=12 core=1 HZ=100  | stack=0x72e0493000-0x72e0495000

stackSize=1039KB  | held mutexes=

  at com.android.server.audio.MediaFocusControl.updateCurrentAudioFocus(MediaFocusControl.java:1309)

  - waiting to lock <0x00482233> (a java.lang.Object) held by thread 155

  at com.android.server.audio.AudioService$IDCMciroFeedback.onAudioFocusIDCMicroChanged(AudioService.java:10884)

  at com.android.server.audio.PlaybackActivityMonitor$AudioIDCMicroRequestCallback.onAudioFocusRemoteChanged(PlaybackActivityMonitor.java:1156)

  at com.android.server.audio.AudioIDCMicroNegotiator$IDCMicroAudioFocusHandler.run(AudioIDCMicroNegotiator.java:507)

  - locked <0x07fc6093> (a java.lang.Object)

"Binder:1501_1F" prio=5 tid=155 Blocked  | group="main" sCount=1 ucsCount=0 flags=1 obj=0x16041d10 self=0xb4000075401f5c30  | sysTid=29764 nice=-10

cgrp=default sched=0/0 handle=0x72ddf3ccb0  | state=S schedstat=( 147904671145 114393348631 934489 ) utm=10868 stm=3921 core=3 HZ=100  |

stack=0x72dde45000-0x72dde47000 stackSize=991KB  | held mutexes=

  at com.android.server.audio.PlaybackActivityMonitor.restoreVShapedPlayers(PlaybackActivityMonitor.java:629)

  - waiting to lock <0x004acb69> (a java.lang.Object) held by thread 158

  at com.android.server.audio.MediaFocusControl.restoreVShapedPlayers(MediaFocusControl.java:134)

  at com.android.server.audio.FocusRequester.handleFocusGainFromRequest(FocusRequester.java:364)

  at com.android.server.audio.MediaFocusControl.requestAudioFocus(MediaFocusControl.java:1048)

  - locked <0x00482233> (a java.lang.Object)

  at com.android.server.audio.AudioService.requestAudioFocus(AudioService.java:8412)

  at android.media.IAudioService$Stub.onTransact(IAudioService.java:1878)

  at android.os.Binder.execTransactInternal(Binder.java:1179)

  at android.os.Binder.execTransact(Binder.java:1143)

"Binder:1501_14" prio=5 tid=158 Blocked  | group="main" sCount=1 ucsCount=0 flags=1 obj=0x160417e8 self=0xb400007540162020  | sysTid=20907 nice=0 cgrp=default

sched=0/0 handle=0x73234c4cb0  | state=S schedstat=( 123640061396 96672619759 758987 ) utm=9164 stm=3199 core=2 HZ=100  | stack=0x73233cd000-0x73233cf000

stackSize=991KB  | held mutexes=

  at com.android.server.audio.AudioIDCMicroNegotiator$IDCMicroAudioFocusHandler.notifyFocusState(AudioIDCMicroNegotiator.java:484)

  - waiting to lock <0x07fc6093> (a java.lang.Object) held by thread 98

  at com.android.server.audio.AudioIDCMicroNegotiator$IDCMicroAudioFocusHandler.obtainFocusState(AudioIDCMicroNegotiator.java:474)

  at com.android.server.audio.AudioIDCMicroNegotiator.requestIDCMicroAudioFocus(AudioIDCMicroNegotiator.java:621)

  - locked <0x0f9449f0> (a java.lang.Object)
  at com.android.server.audio.PlaybackActivityMonitor.requestAudioFocusToIDCM(PlaybackActivityMonitor.java:1253)

  at com.android.server.audio.PlaybackActivityMonitor.playerEvent(PlaybackActivityMonitor.java:276)

  - locked <0x004acb69> (a java.lang.Object)

  at com.android.server.audio.AudioService.playerEvent(AudioService.java:10023)

  at android.media.IAudioService$Stub.onTransact(IAudioService.java:1268)

  at android.os.Binder.execTransactInternal(Binder.java:1184)

  at android.os.Binder.execTransact(Binder.java:1143)

---------------------------

■ 下一步计划

请Audio的同学检查焦点处理逻辑，修复这个问题

#6 - 2023-05-26 14:05 - Multimedia组-RD3_TSCD 梁卿山

- Status changed from ASSIGNED to RESOLVED

- Resolution changed from -- to DUPLICATE

- Root cause set to 和117821问题一致

HI ALL

该问题和以下问题一致，修复代码已经投入，请关闭该问题，谢谢！

https://share.thundersoft.com/redmine/issues/117821

#7 - 2023-05-26 14:06 - Multimedia组-RD3_TSCD 梁卿山

- Assignee changed from Multimedia组-RD3_TSCD 梁卿山 to CDTS-TEST 周婷

#8 - 2023-05-26 18:02 - CDTS-TEST 周婷

117821 处理

#9 - 2023-05-26 18:03 - CDTS-TEST 周婷

- Status changed from RESOLVED to VERIFIED

- Parent task set to #117821

#10 - 2023-06-02 18:27 - CD TEST-方永红

- Status changed from VERIFIED to CLOSED

Files

anr_2023-05-18-04-08-52-211 1.74 MB 2023-05-18 CDTS-TEST 周婷
